SystemOrganization addCategory: #'EjerciciosPoo-OnlineSale'!

Object subclass: #Cart
	instanceVariableNames: 'productsContained productCatalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 19:38'!
newWith: aCatalog

	^self new initializeinitializeWith: aCatalog.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Satelier 6/14/2012 19:32'!
add: aNewProduct quantity: aQuantityOfProduct 
	(aQuantityOfProduct > 0) 
		ifFalse: [self error: 'Cannot add a negative or zero quantity'.].

	(productCatalog includes: aNewProduct) 
		ifFalse: [self error: 'The product does not belong to the editorial'.].
		
	productsContained add: aNewProduct withOccurrences: aQuantityOfProduct.
			
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:51'!
contains: aProduct 
	^ productsContained includes: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 19:37'!
initializeinitializeWith: aCatalog
	productsContained:= Bag new.
	productCatalog:= aCatalog.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 19:44'!
isEmpty 
	^productsContained isEmpty.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:12'!
quantityOf: aProduct
	^productsContained occurrencesOf: aProduct.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 20:56'!
size
	^ productsContained size.! !

Object subclass: #Cashier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!Cashier methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/18/2012 17:04'!
checkOut: aCart withCreditCard: aCreditCard
	(aCart isEmpty ) 
		ifTrue: [self error: 'The cart to be checked out can not be empty'.].

"	(aCreditCard isExpiredOn: (MonthOfYear initializeOnMonthNumber: ((Date today) month) of: ((Date today) year )))
		ifTrue: [self error: 'The credit card is expiried'.].
	(aCreditCard isExpiredOn: (MonthOfYear januaryOf: 2012))
		ifTrue: [self error: 'The credit card is expiried'.]"

	(aCreditCard isExpiredOn: (MonthOfYear onMonthNumber: ((Date today) monthIndex)  of: ((Date today) year)))
	ifTrue: [self error: 'The credit card is expiried'.]. ! !

TestCase subclass: #OnlineSaleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 20:58'!
aCart: aCatalog
	^Cart newWith: aCatalog.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/14/2012 19:35'!
aCashier
	^Cashier new.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/18/2012 00:20'!
aExpirationDate
	
	^MonthOfYear onMonthNumber: ((Date today) monthIndex) - 1 of: ((Date today) year). 
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'Satelier 6/14/2012 20:05'!
aExpiriedCreditCard
	^CreditCard ownedBy: 'Pepe'  identifiedBy:  '123456789' expiresOn: self aExpirationDate. ! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:21'!
aProduct
	^ '1'.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:21'!
aSecondProduct
	^ '2'.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:21'!
aThirdProduct
	^ '3'.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:41'!
aValidCreditCard
	^CreditCard ownedBy: 'Pepe'  identifiedBy:  '123456789' expiresOn: self validExpirationDate. ! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 20:59'!
catalog
	^Set new.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:09'!
test01NewCartCannotContainsProducts

	self assert: ((self aCart: (self catalog)) isEmpty ).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:02'!
test02GivenACartWhenAddAProductThenTheCartContainThis

	| aCart aCatalog aProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add: aProduct.
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	
	self assert: (aCart contains: aProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:08'!
test03GivenACartWhenAddAProductThenTheCartNotContainAnotherProduct

	| aCart aCatalog aProduct aSecondProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add: aProduct.
	aCatalog add: aSecondProduct.
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	
	self deny: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:08'!
test04GivenACartWhenAddAProductThenTheCartContainsTheQuantityAddedOfThatProduct

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add: aProduct.
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	self assert: (aCart size = 3).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:10'!
test05GivenACartWhenAddAProductThatAlreadyExistsThenTheCartContainsTheSumOfTheQuantities

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add: aProduct.
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	aCart add: aProduct quantity: 4.
	self assert: (aCart size = 7).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:16'!
test06GivenACartWhenAddAProductThenTheQuantityShouldNotBeNegative

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add: aProduct.
	aCart := self aCart: aCatalog.
	self should: [ aCart add: aProduct quantity: -1] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText = 'Cannot add a negative or zero quantity').
		self assert: aCart isEmpty.
					
		]
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:16'!
test07GivenACartWhenAddAProductThenTheQuantityShouldNotBeZero

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add: aProduct.
	aCart := self aCart: aCatalog.
	self should: [ aCart add: aProduct quantity: 0] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText='Cannot add a negative or zero quantity').
		self assert: aCart isEmpty.
					
		]


	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:07'!
test08GivenACartWhenAddAProductAndAnotherProductThenTheCartContainsBothProducts

	| aCart aCatalog aProduct aSecondProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add: aProduct.
	aCatalog add: aSecondProduct.

	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	aCart add: aSecondProduct quantity: 1.

	self assert: (aCart contains: aProduct).	
	self assert: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:07'!
test09GivenACartWhenAddAProductAndAnotherProductThenTheCartCanReturnAListOfTheProductsWithItsQuantities

	| aCart aCatalog aProduct aSecondProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add: aProduct.
	aCatalog add: aSecondProduct.

	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	aCart add: aSecondProduct quantity: 1.

	self assert: (aCart contains: aProduct).	
	self assert: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:07'!
test10GivenACartWhenAddAProductAndAnotherProductThenTheCartContainsTheCorrectedQuantityOfThem

	| aCart aCatalog aProduct aSecondProduct aThirdProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add: aProduct.
	aCatalog add: aSecondProduct.

	aCart := self aCart: aCatalog.
	aThirdProduct := self aThirdProduct.
	aCart add: aProduct quantity: 3.
	aCart add: aProduct quantity: 2.
	aCart add: aSecondProduct quantity: 1.

	self assert: ((aCart quantityOf: aProduct) = 5).	
	self assert: ((aCart quantityOf: aSecondProduct) = 1).
	self assert: ((aCart quantityOf: aThirdProduct) = 0).! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:20'!
test11GivenACartWhenAddAProductWhichIsNotInTheCatalogThenTrowNotIncludedInCatalogException

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCart := self aCart: aCatalog.
	self should: [ aCart add: aProduct quantity: 1] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText = 'The product does not belong to the editorial').
		self assert: aCart isEmpty.
					
		]
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:39'!
test12AnEmptyCartCannotBeCheckedOut

	| aCart aCatalog  aCashier aCreditCard |
	
	aCatalog := self catalog.
	aCart := self aCart: aCatalog.
	aCashier := self aCashier.
	aCreditCard := self aValidCreditCard.
	self should: [ aCashier checkOut: aCart withCreditCard: aCreditCard ] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText = 'The cart to be checked out can not be empty').
		self assert: (aCart isEmpty).
	
		]
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztyn 6/18/2012 17:03'!
test13ACartCannotBeCheckedOutWithAnExpiriedCreditCard

	| aCart aCatalog  aCashier aCreditCard aProduct validDate |

	aProduct := self aProduct.
	aCatalog := self catalog.
	aCatalog add: aProduct.

	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.

	aCashier := self aCashier.

	aCreditCard := self aExpiriedCreditCard.

	self should: [ aCashier checkOut: aCart withCreditCard: aCreditCard ] raise: Error withExceptionDo: [:anError |

		self assert: (anError messageText = 'The credit card is expiried').
		self assert: (aCart contains: aProduct).
		]
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/18/2012 00:19'!
validExpirationDate
		
		^MonthOfYear onMonthNumber: ((Date today) monthIndex) + 1 of: ((Date today) year).! !
